/* SQLPLUS version   $Name: glite-data-catalog-service-fr_R_2_1_15 $ */
/******  object prototypes for argument passing	*/


declare
da varchar2(2048);
begin

for i in (select * from all_objects where owner=user 
     and object_type='TYPE'
            AND object_name NOT IN ('ACLENTRYO','ACLLIST','BASICPERMISSIONO','PERMISSIONO') 
			and object_name not like 'NESTED%' and generated='N'
      ) loop

			da:='DROP TYPE ' || i.object_name ||' FORCE';		

 	if da is not null then execute immediate da ; end if;
end loop;

end;
/


create or replace type SurlT is table of varchar2(1024);
/

CREATE OR REPLACE TYPE guidO IS object
	(
		guid VARCHAR2(36)
	);

/

CREATE OR REPLACE type guidOT is table of guidO;

/


CREATE OR REPLACE type returnO IS object
	(
	guid VARCHAR2(32000),
	g_index smallint,
	result smallint,
	errString VARCHAR2(1024),
	CONSTRUCTOR FUNCTION returnO(i smallint) RETURN SELF AS RESULT,
--	  CONSTRUCTOR FUNCTION returnO(g in varchar2,idx in smallint,res in smallint, errStr in varchar2) RETURN SELF AS RESULT
 	CONSTRUCTOR FUNCTION returnO(g in varchar2,idx in smallint,res in smallint, errStr in varchar2, foe in  smallint) RETURN SELF AS RESULT
	)
	not final;

/

CREATE OR REPLACE TYPE BODY returnO IS
	CONSTRUCTOR FUNCTION returnO(i smallint) RETURN SELF AS RESULT
	IS
	BEGIN
	SELF.result:= i;
	return;
	END;
 	CONSTRUCTOR FUNCTION returnO(g in varchar2,idx in smallint,res in smallint, errStr in varchar2, foe in smallint)
 	RETURN SELF AS RESULT
 	IS
	BEGIN
	  self.guid:=g;
	  self.g_index:=idx;
	  SELF.result:= res;
	  self.errString:=errStr;
	return;
	END;

END;

/


CREATE OR REPLACE type returnOT is table of returnO;

/

--drop type returnFMO force ;

CREATE OR REPLACE type returnFMO under returnO
	(
	lfn varchar2(32000)
	)
	;

/
CREATE OR REPLACE type returnFMT is table of returnFMO;

/

create or replace type ACLEntrySimpleId as object
  (
	principal_id INTEGER,
	perm smallint
	)
	;

/

create OR REPLACE type ACLSimpleIdList as TABLE of ACLEntrySimpleId;

/
  


create OR REPLACE type ACLEntryIdO as object
	(
	guid VARCHAR2(36),
	principal_id INTEGER,
	perm smallint
--	,acl_type CHAR(1)
	)
	;

/
create OR REPLACE type ACLIdList as TABLE of ACLEntryIdO;

/

--moved to the schema so no dependency on the object table here.


create or replace type PermissionSimpleO as object
   (
   principal_id integer,
   group_id integer,
   userPerm smallint,
   groupPerm smallint,
	 otherPerm smallint,
   acl ACLSimpleIdList
   )
   ;

/

create or replace type PermissionSimpleT is table of PermissionSimpleO;

/

create type PermissionOT as table of PermissionO;

/

create type PermissionEntryO as object
	(  
	item varchar2(32000),
	perm PermissionO
	);

/

create or replace type PermissionEntryT as table of PermissionEntryO;

/

create type PermissionEntryExtO as object
	(
  itemtype smallint,
	item varchar2(32000),
	perm PermissionO
	);

/

create or replace type PermissionEntryExtT as table of PermissionEntryExtO;

/

create or replace type StatO as object
	(
	fileSize decimal(21),
	creationTime timestamp(0)
	)
	not final
	;

/
create or replace type lfnStatO under StatO
	(
		mTime timestamp(0),
		lfntype char(1),
		data varchar(2048),
		validitytTime INTEGER
	)
	;

/

create or replace type GuidStatO under StatO
	(
	checkSum varchar2(32),
	status smallint,
	modifyTime timestamp(0)
	)
	;

/

create or replace type lfnStatT is table of lfnStatO;

/

create or replace type StatT as table of statO;

/

create or replace type GuidStatT as TABLE of GuidStatO;

/

create or replace type surlEntryO as object
	(
	 surl varchar2(1024),
	 modifyTime timeStamp(0),
	 creationTime timeStamp(0),
	 se varchar2(128),
	 master_replica smallint	--tb added
	 )
	 ;

/

create or replace type surlEntryT as table of surlEntryO;

/

create or replace type surlEntryInO as object 
	(
	guid varchar2(36),
	surl varchar2(1024),			
	master_replica decimal(1) , --only one permitted per guid	
	surl_lifetime integer ,	-- required existence in seconds,starting from time_of_creation, 0 if to be deleted manually			
	se varchar2(255) , --should be 255 according to posix
	cTime  timestamp(0) ,
	mTime timestamp(0) 
	)
	;

/
create or replace type 	surlEntryInT as table of surlEntryInO;

/


-- beware - same record defined in replica
create or replace type RCEntryO as object
	(
	guid varchar2(36),
	guidStat GuidStatO,
	surlStats surlEntryT,
	permission PermissionO
	)
	not final
;
/
create or replace type RCEntryT as table of RCEntryO;

/

create or replace type lfnT as table of varchar(32000);

/

create or replace type principalListT is TABLE of varchar2(1024);

/

create or replace type guidSimpleT is TABLE of varchar2(36);

/

create or replace type bigStringKeyT is TABLE of varchar2(1060);

/


/****** FC/FRC *********/

create or replace type lfnCheckO as object
	(
	lfn varchar2(32000),
	kids lfnT
	);
/
create or replace type lfnCheckT is table of lfnCheckO;
/

create or replace type FCEntryO as object
	(
		lfn varchar2(32000),
		guid varchar2(36),
		lfnStat lfnStatO,
		permission PermissionO
	)
  not final
	;
/

create or replace type FCEntryT is table of FCEntryO;

/

create or replace type FCEntryCheckO under FCEntryO
  (
  permitted smallint
  )
  ;
/

create or replace type FCEntryCheckT is table of FCEntryCheckO;
/


create or replace type FRCEntryO under RCEntryO
	(
		lfn varchar2(32000),	--full, absolute path
		lfnStat lfnStatO
	)
;
/

create or replace type FRCEntryT is table of FRCEntryO;
/

create or replace type FCRStatusO as object
	(
   idx integer,
	 permitted smallint,
	 file_id integer,
	 parent_id integer,
	 permission PermissionSimpleO
	)
	;

/

create or replace type FCRStatusT is table of FCRStatusO;

/
create or replace type FCRStatusTT is table of FCRStatusT;

/


create or replace type FCRStatusIdxO as object
	(
   guid varchar2(36),
   idx integer,
	 permitted smallint,
	 file_id integer,
	 parent_id integer,
	 permission PermissionSimpleO
	)
	;

/

create or replace type FCRStatusIdxT is table of FCRStatusIdxO;
/

create or replace type FCRStatusExtO as object
	(
	 lfn varchar2(32000),
	 permitted smallint,
	 file_id integer,
	 parent_id integer,
	 permission PermissionSimpleO
	)
	;

/

create or replace type FCRStatusExtT is table of FCRStatusExtO;
/

--drop type FMRStatusO force;
--drop type FMRStatusTT FORCE;
--drop type FMRStatusT FORCE;

create or replace type FMRStatusO as object
	(
	 token varchar2(250),
 	 lev integer,
 	 globalidx integer,
	 permitted smallint,
	 file_id integer,
	 parent_id integer,
	 permission PermissionSimpleO
	)
	;
/


create or replace type FMRStatusT is table of FMRStatusO;
/


create or replace type FMRStatusTT is table of FMRStatusT;
/




--drop type FMRStatusZ force;

--create or replace type FMRStatusZ as object
--	(
--	 token varchar2(250),
-- 	 lev integer,
-- 	 globalidx integer,
--	 s FMRStatusT
--	)
--	;
--
--/

create or replace type listNum is TABLE of integer;
/


create or replace type FMRStatusZ as object
	(
	 token varchar2(32000),
 	 lev integer,
 	 subToken varchar2(1024)
	--	 indices listNum
	)
	;
/

create or replace type FMRStatusZT is table of FMRStatusZ;
/


create or replace type FullFCRO as object
	(
		permitted smallint,
		file_id integer,
		entry FRCEntryO
	)
;
/
CREATE or replace type FullFCRT as table of FullFCRO;

/


create or replace type RmDirStatusO as object
  (
   lfn  varchar2(32000),
   parent_id integer,
   file_id integer,
   permitted smallint
   );

/

create or replace type RmDirStatusT as table of RmDirStatusO;

/


--drop type updateFCO force;

create or replace type updateFCO is object
   (
   item varchar2(32000),
   parent_id integer,
   file_id integer,
   bp basicPermissionO
   );

/
create or replace type updateFCT is table of updateFCO;

/

--create or replace type updateFCFullO is object
--  (
--    idx integer,
--    item varchar2(32000),
--    parent_id integer,
--    file_id integer,
--    var integer
--  )
--  ;
--/
--
--create or replace type updateFCFullT is table of updateFCFullO
--;
--/


create or replace type updateFCSimpleO is object
   (
   parent_id integer,
   file_id integer,
   guid varchar2(36),
   item varchar2(32000)
   );
/
create or replace type updateFCSimpleT is table of updateFCSimpleO;
/




create or replace type FCTableO as object
	(
			parent_id integer ,
			file_id integer ,
			name varchar2(250) ,					-- could be autogen for dangling guids, parent_id is predefined then too
			TYPE char(1),							-- dir, file, symlink, virtualdir: d,f,s,z,v, could be constraint'ed
			guid varchar2(36),  					-- depending on the symlink implementation, zeroed if null			
			cTime timestamp(0),   --or taken from the serivce
			mTime timestamp(0),			
			file_size decimal(21),
			lfn_lifetime integer,
			file_checksum CHAR(32),				-- md5 as described in rfc1321,was DEFAULT '00000000000000000000000000000000' 
			status decimal(1),			
			principal_id integer,
			group_id integer ,  					
			userperm decimal(3),
			groupperm decimal(3),
			otherperm decimal(3),	
			dangling_ok	char(1), -- lfn not required for such guids so dont check for dangling refs, means we allow lfnless operations			
			data varchar2(2048) 	--
	)
	;
/

create or replace type FCTableT is table of FCTableO;
/

create or replace type FCCreateO as object
  ( 
  idx integer,
  parent_id integer,
  file_id integer,
  permission PermissionSimpleO  
  )
  ;
/
create or replace type FCCreateT is table of FCCreateO;
/


create or replace type DefaultsO is object
	(
	defaultCreateLFN char(1),
	defaultCreateLFNPattern varchar2(1024),
	defaultParent integer
	)
	;
/



create or replace type principalName AS object 
	(
		name varchar2(1024)
--		,p_type CHAR(1)
	);
/
CREATE or replace type principalNameListT is TABLE of principalName;
/*CREATE or replace type principalNameListT is TABLE of VARCHAR(250);*/
/
CREATE OR REPLACE TYPE genericInteger IS object (val INTEGER);

/

create or replace type principalListIdT is TABLE of genericInteger;

/

CREATE OR REPLACE TYPE principalToken AS object
	(
	user_name VARCHAR2(1024),
	group_names principalNameListT
	)
	;

/

create or replace type StringPairO as object
	(
	string1 varchar2(32000),
	string2 varchar2(1024)
	)
	;

/

CREATE or replace type StringPairT as table of StringPairO;

/

create or replace type IntegerPairO as object
	(
	item1 integer,
	item2 integer
	)
	;

/

CREATE or replace type IntegerPairT as table of IntegerPairO;

/


create or replace type booleanT as table of smallint;

/

create or replace type IntegerTripleO as object
	(
	item1 integer,
	item2 integer,
  item3 integer
	)
	;

/

CREATE or replace type IntegerTripleT as table of IntegerTripleO;

/



create or replace type StringBooleanO  as object
  (
    string varchar2(32000),
    boolVal smallint,
    idx smallint
  )
  ;

/

create or replace type StringBooleanT as table of StringBooleanO;

/

CREATE OR REPLACE TYPE BasicPermissionMapperO AS object
	(
		guid char(36) ,  	--omni-key
		principal_id integer,  
		group_id integer ,  --refrences principal_id from principal tbl
		userperm smallint ,	-- [r|w|x|l|d|p|sm|gm] - 8 bits vector, up to 256dec, always exist 3x per guid
		groupperm smallint,	-- [r|w|x|l|d|p|sm|gm] - 8 bits vector, up to 256dec, always exist 3x per guid
		otherperm smallint 	-- [r|w|x|l|d|p|sm|gm] - 8 bits vector, up to 256dec, always exist 3x per guid
	)
	;

/

CREATE OR REPLACE TYPE BasicPermissionMapperT AS TABLE OF BasicPermissionMapperO
;
/


create or replace type PermStringIntPairO as object
	(
	item1 varchar2(250),
	item2 INTEGER
	)
	;

/
create or replace type PermStringIntPairOT is table of PermStringIntPairO;

/



CREATE OR REPLACE type dataAndStatusO AS object
	(
	guid VARCHAR2(36),
	permitted decimal(1)
	)
	;

/

CREATE OR REPLACE type dataAndStatusOT is table of dataAndStatusO;

/

/* metadata stuff */

create or replace type stringT is table of varchar2(1024);

/


CREATE OR REPLACE type AttributeO AS object
	(
	name VARCHAR2(256),
	atttype varchar2(32),
  value varchar2(1024)
	)
	;

/
CREATE OR REPLACE type AttributeOT is table of AttributeO;

/


CREATE OR REPLACE type AttributeInternalO AS object
	(
	name_id integer,
	val varchar2(1024)  
	)
	;

/
CREATE OR REPLACE type AttributeInternalOT is table of AttributeInternalO;

/

create or replace type metaObjectIntO as object
	(
		schemaid integer,
		attid integer,
		attname varchar2(255),
		toinsert number(1),
		attype varchar2(255),
		val varchar2(255)
	)
	;
/

create or replace type metaObjectIntT is table of metaObjectIntO;
/

create or replace function pipePermissionEntryExt(perms in PermissionEntryExtT,typ in integer)
return PermissionEntryExtT
deterministic
pipelined
is
begin
  for i in 1..perms.count loop
	if typ=perms(i).itemtype then
		pipe row (perms(i));
	end if;
  end loop;
end;

/

create or replace function pipePermissionEntryExtV(perms in PermissionEntryExtT,typ in integer)
return lfnT
deterministic
pipelined
is
begin
  for i in 1..perms.count loop
	if typ=perms(i).itemtype then
		pipe row (perms(i).item);
	end if;
  end loop;
end;

/


create or replace type pathObjectO2 as object
	(
		lev smallint,
		path varchar2(32000),
		token varchar2(250),
		parent_token varchar2(250),
		idx integer
	)
	;
/

create or replace type pathObject2T is table of pathObjectO2;
/

create or replace function pipeTokenizedLfns (path in varchar2,lvl in pls_integer)
return FMRStatusZT
pipelined
deterministic
is
lev pls_integer;
ending pls_integer;
token varchar2(32000);
begin

	lev:=lvl;
    <<tokens>>
  	loop
	   	ending:=INSTR(path,'/',1,lev+1);
		IF ending=0 THEN
		ending:=LENGTH(path)+1;
		token:=SUBSTR(path,1,ending-1);
		pipe row (FMRStatusZ(token,lev,SUBSTR(token,INSTR(token,'/',1,lev)+1)));
		exit;
		END IF;
	    token:=SUBSTR(path,1,ending-1);
		pipe row (FMRStatusZ(token,lev,SUBSTR(token,INSTR(token,'/',1,lev)+1)));
		lev:=lev+1;
  	end loop tokens;


end;
/


create or replace function pipeTokenizedLfnsO2 (lfns in lfnT)
return pathObject2T
pipelined
deterministic
is
ending INTEGER;
endingOld integer:=-1;
lev integer;
path varchar2(32000);
begin


  for i in 1..lfns.count loop
    lev :=1;
  	path :=lfns(i);
    <<tokens>>
  	loop
  		    lev:=lev+1;
        	ending:=INSTR(path,'/',1,lev);
			IF ending=0 THEN
			ending:=LENGTH(path)+1;
			pipe row (pathObjectO2(lev-1,path,SUBSTR(path,1,ending-1),SUBSTR(path,1,endingOld-1),i));
			exit;
			END IF;
		pipe row (pathObjectO2(lev-1,path,SUBSTR(path,1,ending-1),SUBSTR(path,1,endingOld-1),i));
		endingOld:=ending;
  	end loop tokens;

  end loop;
end;
/



create or replace type ResolverO is object
	(
		idx integer,
		parent_id number(38),
		file_id number(38),
		fname varchar2(32000),
		guid varchar2(36),
		ftype char(1),
		ctime timestamp(0),
		mtime timestamp(0),
		file_size number(21),
		file_checksum char(32),
		LFN_LIFETIME number(38),
		status number(1),
		principal_id NUMBER(38),
		group_id NUMBER(38),
		userperm NUMBER(3),
		groupperm NUMBER(3),
		otherperm NUMBER(3),
		dangling_ok char(1),
		data varchar2(4000),
		permission smallint,
	 	CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,iperm in smallint) return SELF as result,
	 	CONSTRUCTOR FUNCTION ResolverO(iidx in integer,iparent_id in integer,ifile_id in integer,ifnam in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result,
 	 	CONSTRUCTOR FUNCTION ResolverO(idx in integer,s in ResolverO) return SELF as result,
    CONSTRUCTOR FUNCTION ResolverO(idx in integer,inName in varchar2) return SELF as result,
 		CONSTRUCTOR FUNCTION ResolverO(s in ResolverO, per in smallint) return SELF as result,
		CONSTRUCTOR FUNCTION ResolverO(idx in integer, s in ResolverO, per in smallint) return SELF as result,    
		CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result,
		CONSTRUCTOR FUNCTION ResolverO(idx in integer, per in smallint) return SELF as result,
		CONSTRUCTOR FUNCTION ResolverO(idx in integer, per in smallint, g in varchar2) return SELF as result,
		CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,iguid in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result,
		member function getReturn return returnO,
		member function getStringPairO return StringPairO,
		member function getFCRStatusIdxO return FCRStatusIdxO
 	 )
 	 ;
/


CREATE OR REPLACE TYPE BODY ResolverO IS
 	CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,iperm in smallint) return SELF as result
	IS
	BEGIN

	  self.parent_id:=iparent_id;
	  self.file_id:=ifile_id;
 	  self.fname:=ifnam;
  	self.permission:=iperm;
	return;
	end;
	CONSTRUCTOR FUNCTION ResolverO(iidx in integer,iparent_id in integer,ifile_id in integer,ifnam in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result
	IS
	BEGIN
	  self.idx:=iidx;
	  self.parent_id:=iparent_id;
	  self.file_id:=ifile_id;
 	  self.fname:=ifnam;
  	  self.principal_id:=uidd;
   	  self.group_id:=gid;
   	  self.userperm:=uperm;
   	  self.groupperm:=gperm;
   	  self.otherperm:=operm;
	return;
	end;
	CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result
	IS
	BEGIN
	  self.parent_id:=iparent_id;
	  self.file_id:=ifile_id;
 	  self.fname:=ifnam;
  	  self.principal_id:=uidd;
   	  self.group_id:=gid;
   	  self.userperm:=uperm;
   	  self.groupperm:=gperm;
   	  self.otherperm:=operm;
	return;
	end;
	CONSTRUCTOR FUNCTION ResolverO(iparent_id in integer,ifile_id in integer,ifnam in varchar2,iguid in varchar2,uidd in integer, gid in integer, uperm in integer ,gperm in integer ,operm in integer) return SELF as result
	IS
	BEGIN
	  self.parent_id:=iparent_id;
	  self.file_id:=ifile_id;
 	  self.fname:=ifnam;
	  self.guid:=iguid;
  	  self.principal_id:=uidd;
   	  self.group_id:=gid;
   	  self.userperm:=uperm;
   	  self.groupperm:=gperm;
   	  self.otherperm:=operm;
	return;
	end;

	CONSTRUCTOR FUNCTION ResolverO(idx in integer,s in ResolverO) return SELF as result
	IS
	BEGIN
	  if s is not null then self:=s; end if;
	  self.idx:=idx;
	return;
	end;

	CONSTRUCTOR FUNCTION ResolverO(idx in integer, per in smallint) return SELF as result
	IS
	BEGIN
	  self.permission:=per;
	  self.idx:=idx;
	return;
	end;

  CONSTRUCTOR FUNCTION ResolverO(idx in integer,inName in varchar2) return SELF as result
	IS
	BEGIN
	  self.fname:=inName;
	  self.idx:=idx;
	return;
	end;

	CONSTRUCTOR FUNCTION ResolverO(idx in integer, per in smallint, g in varchar2) return SELF as result
	IS
	BEGIN
	  self.permission:=per;
	  self.idx:=idx;
	  self.fname:=g;
	return;
	end;

	CONSTRUCTOR FUNCTION ResolverO(s in ResolverO, per in smallint) return SELF as result
	IS
	BEGIN
	  if s is not null then self:=s; end if;
	  self.permission:=per;
	return;
	end;

	CONSTRUCTOR FUNCTION ResolverO(idx in integer, s in ResolverO, per in smallint) return SELF as result
	IS
	BEGIN
	  if s is not null then self:=s; end if;
	  self.permission:=per;
	  self.idx:=idx;
	return;
	end;

  member function getReturn return returnO
	is
	begin
	    return  case permission
	    WHEN 1 THEN
            null
     	when 0 then
          returnO
                (fname,idx,
                 Permission_Util.accessDeniedErrVal,
                 Permission_Util.accessDeniedErrStr
                )
          WHEN 2 THEN returnO
                (fname,idx,
                 Permission_Util.NoSuchFileVal, --no parent directory exists
                 Permission_Util.NoSuchFileStr
                )
          WHEN permission_util.loopInSymlinksDetectedVal THEN
             returnO
              (
              fname,idx,
              Permission_Util.loopInSymlinksDetectedVal, --no parent directory exists
              Permission_Util.loopInSymlinksDetectedStr
              )
          ELSE returnO
                (fname,idx,
                 Permission_Util.NoSuchFileVal, --no parent directory exists
                 Permission_Util.NoSuchFileStr
                )
                END;
	end;

	member function getStringPairO return StringPairO
		is
		begin
		return case permission
		    WHEN 1 THEN
                StringPairO(fname,guid)
            else
            null
            end;


		end;

	member function getFCRStatusIdxO return FCRStatusIdxO
		is
		begin
		return
			case
				when permission =1  then
				FCRStatusIdxO(guid,idx,permission,file_id,parent_id,null)
				else
				null
				end;

		end;

end;
/


create or replace type ResolverT is table of ResolverO;
/

