/* In this file predefined permission and user is created.
	
	Substitute username,groupnames with the ones you'd like to be superusers,
	usere who are able to change globalpermissions for now.
	In the future we may think of skipping permission check for them 
	for at least chosen operations.
	
	WARNING:
	admin principal _should_not be egee - it should be rather some su.
*/

declare
	ret returnO;
	outErrors returnOT;

	globalDefaultGuid varchar2(36):='10000000-0000-0000-0000-000000000000';
	globaDefultLFNPattern varchar2(1024):=
		'/%vo/%user/experiment/%username-%time.grd';


	principalDN varchar(250):='egee'; -- first superuser
	principalGroup varchar(250):='nobody'; -- first supergroup

	token principalToken:=principalToken(principalDN,
			principalNameListT(
			  principalName(principalGroup),
			  principalName('super-group')));


	perm PermissionEntryT:=
	PermissionEntryT
		(
		PermissionEntryO
			 (
			 globalDefaultGuid,
				PermissionO(principalDN,principalGroup,
					255, --bin_to_num(1,1,1,1,1,1,1,1),  [w|r|x|l|d|p|sm|gm]
					112, --bin_to_num(0,1,1,1,0,0,0,0),  [w|r|x|l|d|p|sm|gm]
					81, --bin_to_num(0,1,0,1,0,0,0,1),   [w|r|x|l|d|p|sm|gm]
					null) -- should have all admins here with full
				)
      );
	pId integer;

begin
 	/* add permission used while looking defaults up */

	ret:=permission_util.addGuid(
				 token,
				 perm,  
				 outerrors);
  if ret.result<>0 then raise_application_error(-23332,'Could not set perms on global defaults: '||ret.errString); end if;

	/** predefined global settings for non existing user , deafultparent is /tmp id=2 */
	insert into perm_principal(principal_id,name,p_type)
					values(fc_principal_id_seq.nextval,'Admin','a')
			returning principal_id into pId;
      
  

	insert into perm_principal_defaults values(
			 	pId, --global id for non-ex user
				globalDefaultGuid,
        '0',
        globaDefultLFNPattern, -- reserved for future
				2, --tmp by default, users have private home dirs
				PermissionO(principalDN,principalGroup,
					bin_to_num(1,1,1,1,1,1,1,1), --255
					bin_to_num(0,1,0,1,0,0,0,0), --80
					bin_to_num(0,0,0,0,0,0,0,0), --0
					null
						  )
			 		);
commit;
end;


