-- deletion of user objects
-- do not run this script as DBA!!!!
-- it preserves versioning table
declare
killer varchar2(2048);
begin

for i in (select * from all_objects where owner=user 
      and object_name not in ('FM_SCHEMA_VERSION') 
			and object_name not like 'NESTED%' and generated='N' and object_name not like 'BIN%'
      ) loop

	killer:=case i.object_type
		when 'TYPE' then 'DROP TYPE ' || i.object_name ||' FORCE'
		when 'TABLE' then 'DROP TABLE ' ||i.object_name ||' cascade constraints'
		when 'PACKAGE' then 'DROP PACKAGE ' ||i.object_name
		when 'FUNCTION' then 'DROP FUNCTION ' ||i.object_name
		when 'SEQUENCE' then 'DROP SEQUENCE ' ||i.object_name
		when 'SYNONYM' then 'DROP SYNONYM '   ||i.object_name ||' FORCE'
		end;

 	if killer is not null then execute immediate killer ; end if;
end loop;
  
  -- version tag is empty, means no schema loaded so far
  -- getVersion or apps using it should react properly
  
  DECLARE
  BEGIN
  execute immediate 'INSERT INTO fm_schema_version(version_tag) values('' '')';
  EXCEPTION
  WHEN OTHERS THEN
  EXECUTE IMMEDIATE 'CREATE TABLE fm_schema_version (
            version_tag varchar2(1024),
            creation timestamp(0) default systimestamp not NULL,
            constraint pck_version_constraint primary key(version_tag,creation)
            )
            organization INDEX
            COMPRESS 1';
  end;
commit;
END;
/
