
create or replace function siwtchPermissionBits(i in pls_integer)
return pls_integer
deterministic
as
o plS_integer;
begin
	select decode(bitand(bin_to_num(1,1,0,0,0,0,0,0) ,i),
	bin_to_num(0,1,0,0,0,0,0,0), i+64,
	bin_to_num(1,0,0,0,0,0,0,0), i-64,
	i)
	collect into o
	from dual;

	return o;
end;
/


declare

begin
/* This is experimental update for exisiting schemas. 
	Updates default bits to proper values and creates root for user directory with proper permission bits 
	if does not exist
*/
/* alter name size for those who still did not */
execute immediate 'alter table fc_file MODIFY name varchar2(1024)' ;

 -- update all default bits
	UPDATE pd SET (perm)=PermissionO('egee','egee',
					bin_to_num(1,1,1,1,1,1,1,1),
					bin_to_num(0,1,1,1,0,0,0,0),
					bin_to_num(0,1,0,0,0,0,0,0),
					null ),
					defaultparent=2
	WHERE guid ='10000000-0000-0000-0000-000000000000'  
;

 -- change root permissions (?)

 -- create user home root dir or update permission bits if already there
   	  	MERGE /*+ cardinality (S 100) */ INTO fc_file D
      USING (SELECT 1 parent_id,
		'00000000-0000-0000-0000-000000000003' guid,
		'user' name,'d' type,
		0 principal_id,0 group_id,
		bin_to_num(1,1,1,1,1,1,1,1) userperm,bin_to_num(1,0,0,1,0,0,0,0) groupperm ,bin_to_num(1,1,0,1,0,0,0,0) otherperm from dual) S
      ON (S.name=D.name and D.parent_id=1 )
      WHEN MATCHED THEN UPDATE SET userperm = bin_to_num(1,1,1,1,1,1,1,1), groupperm = bin_to_num(0,1,1,1,0,0,0,0),otherperm = bin_to_num(0,1,0,0,0,0,0,0)
      WHEN NOT MATCHED THEN INSERT(parent_id,file_id,guid,name, type,principal_id,group_id,userperm,groupperm,otherperm)
       VALUES(S.parent_id,fc_principal_id_seq.nextval ,S.guid,S.name, S.type,s.principal_id,s.group_id,s.userperm,s.groupperm,s.otherperm);


  -- apply only from  v. 2.1.7 to previous ones (over 2.x)
  update fc set
	userperm=siwtchPermissionBits(userperm),
	groupperm=siwtchPermissionBits(groupperm),
	otherperm=siwtchPermissionBits(groupperm)
	;
  
  update acl set perm = siwtchPermissionBits(perm);

  commit;
end;
/
