CREATE OR REPLACE 
PACKAGE FIREMAN AS

/*public void create(FRCEntry[] entries) throws CatalogException, AuthorizationException, ExistsException, NotExistsException, InvalidStatException;*/
function FRCCreate(securityToken in principalToken,
          entries in FRCEntryT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public FCEntry[] readDir(String path, String pattern, long limit, long offset, boolean withPermissions)  */
function readDir(securityToken in principalToken,
        path in varchar2,
        pattern in varchar2,
        limit in pls_integer,
        offset in pls_integer,
        wPerms in pls_integer,
        outEntries out nocopy FRCEntryT,
        outerrors out nocopy returnOT)
  return returnO;

/*+ public FRCEntry[] listReplicas(String[] lfns, boolean withPermissions) throws CatalogException, AuthorizationException, NotExistsException;*/
function listReplicas(securityToken in principalToken,
			 lfns in lfnT,
			 wPerms in pls_integer,
			 outEntries out nocopy FRCEntryT,
       outerrors out nocopy returnOT)
  return returnO;

/*+ public String[] listLfn(String[] surls) throws CatalogException, AuthorizationException, NotExistsException;*/
function listLfn(securityToken in principalToken,
          surls in surlT,
          outEntries out nocopy StringPairT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public Stat[] getStat(String[] lfns) throws CatalogException, AuthorizationException, NotExistsException;*/
function getStat(securityToken in principalToken,
          lfns in lfnT,
			 outEntries out nocopy statT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void updateStat(Stat[] stats) throws CatalogException, AuthorizationException, InvalidStatException, NotExistsException;*/
function updateStat(securityToken in principalToken,
          stats in statT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public PermissionEntry[] getPermission(String[] lfns) throws CatalogException, AuthorizationException, NotExistsException;*/
function getPermission(securityToken in principalToken,
          items in StringBooleanT,
          outEntries out nocopy PermissionEntryT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void setPermission(PermissionEntry[] permissions) throws CatalogException, AuthorizationException, NotExistsException, InvalidStatException;*/
function setPermission(securityToken in principalToken,
          permissions  in PermissionEntryExtT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void addReplica(String lfn, SURLEntry[] newSurls) throws CatalogException, AuthorizationException, ExistsException, InvalidStatException;*/
function addReplica(securityToken in principalToken,
          lfn in varchar2,
          newSurls in surlEntryT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void remove(String[] lfns) throws CatalogException, AuthorizationException, NotExistsException;*/
function remove(securityToken in principalToken,
          lfns in lfnT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void removeReplica(StringPair[] lfnSurls, boolean removeLfnOnLastReplica)*/
function removeReplica(securityToken in principalToken,
          entries in StringPairT,
          removeLfnOnLastReplica in smallint,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public GUIDStat[] listGuidsWithoutLfn(String filter) throws CatalogException, AuthorizationException;*/
function listGuidsWithoutLfn(securityToken in principalToken,
          filter in varchar2,
          outEntries out nocopy guidStatT,
          outerrors out nocopy returnOT)
  return returnO;


/******************************** FC derived **********************/
/*+ public void createFile(FCEntry[] entries) */
function createFile(securityToken in principalToken,
          entries in FCEntryT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public void mkdir(String[] directory, boolean createParents, boolean copyPermFromParent)*/
function mkdir(securityToken in principalToken,
          entries in lfnT,
          wParents in smallint,
          copyPermFromParent in smallint,
          outerrors out nocopy returnOT)
  return returnO;


-- forward definitions for perm_util user dir creation
function mkdirParents (
    securityToken IN principalToken,
    userPrincipal PERM_PRINCIPAL.principal_id%TYPE,
    principals PermStringIntPairOT,
    entries IN lfnT,
    copyPermFromParent IN SMALLINT,
    outerrors IN OUT NOCOPY returnOT,
    ignoreExistingLeaf in boolean:=false
          )
RETURN returnO;


/*+ public void rmdir(String[] directory, boolean recursive) throws CatalogException, AuthorizationException, ExistsException, NotExistsException; */
function rmdir(securityToken in principalToken,
          entries in lfnT,
          recursive in smallint,
          outerrors out nocopy returnOT)
  return returnO;


/*  + public void mv(StringPair[] entry) throws CatalogException, AuthorizationException, ExistsException, NotExistsException;*/
function mv(securityToken in principalToken,
          entries in StringPairT,
          outerrors out nocopy returnOT)
  return returnO;

--/*+ public FCEntry[] readDirBasic(String path, String pattern, long limit, long offset, boolean withPermissions) throws CatalogException, AuthorizationException, NotExistsException, CatalogException;*/
--function readDirBasic(securityToken in principalToken,
--			 path in varchar2,
--			 pattern in varchar2,
--			 limit in integer,
--			 offset in integer,
--			 wPerm in integer,
--       outEntries out nocopy FCEntryT,
--       outerrors out nocopy returnOT)
--  return returnO;

/*+ public String[] locate(String startDir, String pattern) throws CatalogException, AuthorizationException, NotExistsException;*/
function locate(securityToken in principalToken,
			startDir in varchar2,
			pattern in varchar2,
      limit in smallint,
			outEntries out nocopy lfnT,
      outerrors out nocopy returnOT)
  return returnO;

/*+ public StringPair[] getGuidForLfn(String[] lfn) throws CatalogException, AuthorizationException, NotExistsException;*/
function getGuidForLfn(securityToken in principalToken,
          lfns in lfnT,
          outEntries out nocopy StringPairT,
          outerrors out nocopy returnOT)
  return returnO;


/*+ public StringPair[] getLfn(String[] guid) throws CatalogException, AuthorizationException, NotExistsException;*/
function getLfn(securityToken in principalToken,
          guids in guidSimpleT,
          outEntries out nocopy StringPairT,
          outerrors out nocopy returnOT)
  return returnO;

/*+ public FCEntry[] getLfnStat(String[] lfn) throws CatalogException, AuthorizationException, NotExistsException;*/
function getLFNStat(securityToken in principalToken,
          lfns in lfnT,
          outEntries OUT NOCOPY lfnStatT,
          outerrors out nocopy returnOT)
  return returnO;

/* public FCEntry[] getFileCatalogEntry(String[] lfns) */
function getFileCatalogEntry(securityToken in principalToken,
       lfns in lfnT,
       outEntries out nocopy FCEntryT,
       outerrors out nocopy returnOT)
  return returnO;

/* public StringPair[] getLfnForGuid(String[] guids) */
function getLfnForGuid(securityToken in principalToken,
          guids in lfnT,
          outEntries out nocopy StringPairT,
          outerrors out nocopy returnOT)
  return returnO;

/* public void symlink(StringPair[] symlinks, boolean copyPermFromParent) */
function symlink(securityToken in principalToken,
          entries in StringPairT,
          copyPermFromParent in smallint,
          outerrors out nocopy returnOT)
  return returnO;

/* Delete an LFN, symlink or virtual directory. Use rmdir for normal directories.
    public void unlink(String[] lfns)  */
function unlink(securityToken in principalToken,
          lfns in lfnT,
          outerrors out nocopy returnOT)
  return returnO;



/* public void updateModifyTime(String[] lfns, long time) */
function updateModifyTime(securityToken in principalToken,
       lfns in lfnT,
       inTime in pls_integer,
       outerrors out nocopy returnOT)
  return returnO;


/* public void updateValidityTime(String[] lfns, long time) */
function updateValidityTime(securityToken in principalToken,
       lfns in lfnT,
       intime in pls_integer,
       outerrors out nocopy returnOT)
  return returnO;

/* FASBase */
/* public void checkPermission(String[] items, Perm perm)
   Entries have info on the type of the item 0-guid, 1-llfn so we dont stress db with parsing */

function checkPermission(securityToken in principalToken,
          entries in StringBooleanT,
          perm in smallint,
          outerrors out nocopy returnOT)
  return returnO;





/************************* RC **********************************/

function createGuid(securityToken in principalToken,
        entries in RCEntryT,
        outerrors out nocopy returnOT)
  return returnO;

function addGuidReplica(securityToken in principalToken,
        inguid in varchar2,
        newSurls in SURLEntryT,
        outerrors out nocopy returnOT)
  return returnO;

function updateGuidStat(securityToken in principalToken,
          guids in guidOT,
          stats in GuidStatT,
          outerrors out nocopy returnOT)
  return returnO;

function updateSurlStat(securityToken in principalToken,
          inguid in varchar2,
          surlStat in SURLEntryT,
          outerrors out nocopy returnOT)
  return returnO;

function setMasterReplica(securityToken in principalToken,
          guidSurl in StringPairT,
          outerrors out nocopy returnOT)
  return returnO;

function updateStatus(securityToken in principalToken,
          guids in guidOT,
          status in integer,
          mask in integer,
          outerrors out nocopy returnOT)
  return returnO;

function removeGuidReplica(securityToken in principalToken,
          guidSurl in StringPairT,
          removeGuidOnLastReplica in smallint,
          outerrors out nocopy returnOT)
  return returnO;


function removeGuid(securityToken in principalToken,
          guids in guidOT,
          outerrors out nocopy returnOT)
  return returnO;


function setGuidPermission(securityToken in principalToken,
          permissions in PermissionEntryT,
          outerrors out nocopy returnOT)
  return returnO;

/* public void setDefaultPrincipalPermission(String principal, Permission defaultPermission)  */
function setDefaultPrincipalPermission(securityToken in principalToken,
          principal in varchar2,
          defaultPermission in PermissionO,
          outerrors out nocopy returnOT)
	return returnO;


function setDefaultGlobalPermission(securityToken in principalToken,
          defaultPermission in PermissionO,
          outerrors out nocopy returnOT)
	return returnO;

/* getters */

function getGuidPermission(securityToken in principalToken,
        guids in guidOT,
        outEntries out nocopy PermissionEntryT,
        outerrors out nocopy returnOT)
	return returnO;


function getGuidForSurl(securityToken in principalToken,
        surls in surlT,
        outEntries out nocopy StringPairT,
        outerrors out nocopy returnOT)
	return returnO;


function getMasterReplica(securityToken in principalToken,
        guids in guidOT,
        outEntries out nocopy StringPairT,
        outerrors out nocopy returnOT)
	return returnO;


function listSurlsByGuid(securityToken in principalToken,
        guids in guidOT,
        outEntries out nocopy StringPairT,
        outerrors out nocopy returnOT)
	return returnO;


function listReplicasByGuid(securityToken in principalToken,
        guids in guidOT,
        withPermissions in integer,
        outEntries out nocopy RCEntryT,
        outerrors out nocopy returnOT)
	return returnO;


function hasGuid(securityToken in principalToken,
        guids in guidOT,
        outEntries out nocopy StringBooleanT,
        outerrors out nocopy returnOT)
	return returnO;


function getGuidStat(securityToken in principalToken,
        guids in guidOT,
        outEntries out nocopy GuidStatT,
        outerrors out nocopy returnOT)
	return returnO;


function getSurlStat(securityToken in principalToken,
        guidSurls in StringPairT,
        outEntries out nocopy SURLEntryT,
        outerrors out nocopy returnOT)
	return returnO;

/* public Permission getDefaultPrincipalPermission(String principal)  */
function getDefaultPrincipalPermission(securityToken in principalToken,
        principal in varchar2,
        outEntry out nocopy PermissionO,
        outerrors out nocopy returnOT)
	return returnO;


function getDefaultGlobalPermission(securityToken in principalToken,
        outEntry out nocopy PermissionO,
        outerrors out nocopy returnOT)
	return returnO;

/* internal yet */
function getDefaultSettings(securityToken in principalToken,
        outEntry out nocopy DefaultsO
        )
return returnO
;


/************************ MetadataBase *****************/
 /* Sets the values for a group of attributes of an item/entry.
    public void setAttributes(String item, Attribute[] attributes)    */
function setAttributes(securityToken in principalToken,
        item in StringBooleanO,
        attributeNames in AttributeOT,
        outerrors out nocopy returnOT)
	return returnO
  ;

/* Clears the values for a group of attributes.
    public void clearAttributes(String item, String[] attributeNames) */
function clearAttributes(securityToken in principalToken,
        item in StringBooleanO,
        attributeNames in stringT,
        outerrors out nocopy returnOT)
	return returnO;


/* Gets a group of attributes of a given item/entry.
    public Attribute[] getAttributes(String item, String[] attributeNames) */
function getAttributes(securityToken in principalToken,
        item in StringBooleanO,
        attributeNames in stringT,
        outEntries out nocopy AttributeOT,
        outerrors out nocopy returnOT)
	return returnO
  ;


/* List all attributes associated with an entry.
    public Attribute[] listAttributes(String item)     */
function listAttributes(securityToken in principalToken,
        item in StringBooleanO,
        outEntries out nocopy AttributeOT,
        outerrors out nocopy returnOT)
	return returnO
  ;

/* Performs a generic query on the catalog, returning the corresponding item's identifiers.
    public String[] query(String query, String type, int limit, int offset)     */

function query(securityToken in principalToken,
        query in varchar2,
        limit in smallint,
        offset in smallint,
        outEntries out nocopy stringT,
        outerrors out nocopy returnOT)
	return returnO
  ;

/* pre admin iface */
function SetSuperusers(
        names in lfnT)
  return returnO
;


/*************** SEIndex helpers ***************/
/*  public String[] listSEbyLFN(String lfn) throws DBException, NotExistsException, AuthorizationException */
function listSEbyLFN(securityToken in principalToken,
          lfn in varchar2,
          outEntries OUT NOCOPY lfnT,
          outerrors out nocopy returnOT)
  return returnO;

/* public String[] listSEbyGUID(String guid) throws DBException, NotExistsException */
function listSEbyGUID(securityToken in principalToken,
          iguid in varchar2,
          outEntries OUT NOCOPY lfnT,
          outerrors out nocopy returnOT)
  return returnO;


/* internal get of defaults */


/* internal calls */
function genLfns
	return lfnT
	deterministic;

function genFRCEntryT(n in pls_integer)
	return FRCEntryT
	deterministic
   ;

function genSurls(n pls_integer )
   return surlT
   deterministic
   ;
PRAGMA RESTRICT_REFERENCES (genSurls, WNDS, RNPS, WNPS, RNPS, TRUST);

/* tokenizers for path traversal */
function getNoOfPathDelimiters(inPath in varchar2)
	return PLS_INTEGER
  deterministic
;
PRAGMA RESTRICT_REFERENCES (getNoOfPathDelimiters, WNDS, RNPS, WNPS, RNPS, TRUST);

function getNoOfPathDelimitersRoot(inPath in varchar2)
	return PLS_INTEGER
	Deterministic;
PRAGMA RESTRICT_REFERENCES (getNoOfPathDelimitersRoot, WNDS, RNPS, WNPS, RNPS, TRUST);

function	getPathToken(lev in integer,path in varchar2)
	return fc_file.NAME%type
	DETERMINISTIC;
PRAGMA RESTRICT_REFERENCES (getPathToken, WNDS, RNPS, WNPS, RNPS, TRUST);

function	getPathTokenEx(lev in integer,path in varchar2)
	return fc_file.NAME%type
	DETERMINISTIC;
PRAGMA RESTRICT_REFERENCES (getPathTokenEx, WNDS, RNPS, WNPS, RNPS, TRUST);

function getpathtokenEx2(lev in integer,path in varchar2, name in varchar2 default 'test')
	return fc_file.NAME%type
	DETERMINISTIC;
PRAGMA RESTRICT_REFERENCES (getPathTokenEx2, WNDS, RNPS, WNPS, RNPS, TRUST);

function reversePath(path in varchar2)
	return varchar2
	DETERMINISTIC
   ;
PRAGMA RESTRICT_REFERENCES (reversePath, WNDS, RNPS, WNPS, RNPS, TRUST);


-- symlinks, temporarily external

function getSymlink (path in varchar2)
	return ResolverO
;

END;
