#!/bin/bash
#
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://public.eu-egee.org/partners/ for details on 
# the copyright holders.
# For license conditions see the license file or
# http://eu-egee.org/license.html
#
# Authors: Akos Frohner <Akos.Frohner@cern.ch>

PACKAGENAME=glite-data-catalog-service-fr

source ${GLITE_LOCATION:-/opt/glite}/sbin/glite-data-common-service-configure.sh

#_oracle_create_user
echo "Please ask your Oracle DBA to issue the following commands:"
echo "    create user $DBUSER identified by '$DBPASSWORD';"
echo "    grant resource to $DBUSER;"
echo "    grant create session to $DBUSER;"
echo "    grant create synonym to $DBUSER;"
echo "    grant connect to $DBUSER;"
echo "    grant create any procedure to $DBUSER;"
echo "    grant create any sequence to $DBUSER;"

_get_value DBURL
DBURL="$value"
CLASSPATH=$(echo $(ls $GLITE_LOCATION/lib/glite-data-common/*.jar) | sed -e 's/ /:/g')
echo "Then do the following:"
echo "    cd $GLITE_LOCATION/etc/$PACKAGENAME/schema"
echo "    ant -classpath $CLASSPATH -Doracle.username=$DBUSER -Doracle.password=$DBPASSWORD -Doracle.url='$DBURL' oracle_init_fm" 

_print_cleanup
